import keras
from keras.layers import Input, Dense, Convolution2D, MaxPooling2D, UpSampling2D, Flatten
from keras.models import Model
from keras.datasets import mnist
import numpy as np
from keras.models import Sequential# 导入Sequential
from keras.utils import np_utils, generic_utils
import h5py
# (x_train, y_train), (x_test, y_test)= mnist.load_data()
#
# x_train = x_train.astype('float32') / 255.
#
# x_test = x_test.astype('float32') / 255.
#
# y_train= np_utils.to_categorical(y_train, 10)
#
# y_test=np_utils.to_categorical(y_test, 10)
#
# x_train = x_train.astype('float32') / 255.
# x_test = x_test.astype('float32') / 255.
# x_train = np.reshape(x_train, (len(x_train), 28, 28, 1))
# x_test = np.reshape(x_test, (len(x_test), 28, 28, 1))
dict_data = h5py.File('mydata.mat')

x_train=np.array(dict_data['train_x'])

y_train=np.array(dict_data['train_y'])

x_test=np.array(dict_data['test_x'])

y_test=np.array(dict_data['test_y'])

x_train=np.transpose(x_train)

y_train=np.transpose(y_train)

x_test=np.transpose(x_test)

y_test=np.transpose(y_test)

x_train = x_train.astype('float32')

x_test = x_test.astype('float32')
x_train= np.reshape(x_train,(2000,192,192,3),order="F")
x_test= np.reshape(x_test,(500,192,192,3),order="F")
x_train /=10000

x_test /= 10000

batch_size = 10
#   设置训练一次样本的个数
num_classes =5
#   设置类别数
epochs =200
#   设置循环次数
print(x_train.shape, 'train samples')
print(x_test.shape, 'test samples')
print(y_train.shape, 'train samples')
print(y_test.shape, 'test samples')
#  设置图像长和宽
img_rows=192
img_cols=192
input_shape = (img_rows, img_cols,3)       #   设置输入shape的size
model = Sequential()        #    初始化一个神经网络   线性叠加的，层与层之间是全连接的方式，一个输入，一个输出
model.add(Convolution2D(6, kernel_size=(3, 3),padding='valid',trainable=False,
                 activation='sigmoid',kernel_initializer='glorot_uniform',#基于uniform分布，uniform的默认scale=0.05，而此处scale=sqrt( 6 / (f_in +f_out)) ，其中，f_in和f_out是待初始化矩阵的行和列。
                 input_shape=input_shape,name="layer11"))#add 添加一层神经网(卷积层),大小为5*5，特征图个数为6，激活函数采用sigmoid，卷积核进行初始化，设置input_shape的size
model.add(MaxPooling2D(pool_size=(2, 2),name="layer12"))#add 添加一层神经网(下采样层)
model.load_weights('encoder_cae_3band_6_2.h5')
model.add(Flatten())#压扁平准备全连接
print('一')
# print(model.layers[6].get_weights())
model.add(Dense(num_classes, activation='softmax',kernel_initializer='glorot_uniform',) )#添加全连接
model.compile(loss='binary_crossentropy',#目标函数 平均方差                        compile编译、配置
              optimizer=keras.optimizers.SGD(1),#指定模型训练的优化器，里面有SGD，Adagrad，Adadelta，RMSprop，Adam可选
              metrics=['accuracy'])#指标为准确度
# model.fit用于训练一个固定迭代次数的模型
# 返回：记录字典，包括每一次迭代的训练误差率和验证误差率；
model.fit(x_train, y_train, batch_size=batch_size, epochs=epochs,
          verbose=1, validation_data=(x_test, y_test),shuffle=True)
print('二')
# print(model.layers[6].get_weights())
#verbose : 进度表示方式。0表示不显示数据，1表示显示进度条，2表示用只显示一个数据。
#validation_data : 被用来作为验证数据的(X, y)元组。会代替validation_split所划分的验证数据
#shuffle :是否对每一次迭代的样本进行shuffle操作。shuffle() 方法将序列的所有元素随机排序。
score = model.evaluate(x_test, y_test, verbose=0)#展示模型在验证数据上的效果，返回：误差率或者是(误差率，准确率)元组（if show_accuracy=True）
print('Test loss:', score[0])
print('Test accuracy:', score[1])
x=model.predict(x_test,batch_size=10,verbose=1)
x=model.predict_classes(x_test,batch_size=10,verbose=1)
model.save('cae_192_3band.h5')
np.savetxt('cae_192_3band.csv',x,delimiter=',')
# model.save_weights('neighbourhood_weights.h5')
# data can be load into memory


#data need generate form every epork
#记录数据ID

#读入输入到内存


#fit训练数据
# tensorboard --logdir=D://zqkerasxunlian